﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Text;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.Script.Serialization;
using System.Xml.Linq;

using Dropthings.Widget.Framework;
using Dropthings.Widget.Widgets;

using AcmeCor.EBE.Common.Entities;
using AcmeCor.EBE.Common.Utilities;

using GLSi.Business;
using GLSI.Entities;

using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.WebEdition;


public partial class Widgets_FleetMonitoring_MapSuite4 : System.Web.UI.UserControl, IWidget//, ICallbackEventHandler
{
    #region Fields

    //private IWidgetHost _Host;

    #endregion Fields

    #region Methods

    #region WidgetMethods

    void IEventListener.AcceptEvent(object sender, EventArgs e)
    {
    }

    void IWidget.Closed()
    {
    }

    void IWidget.Collasped()
    {
    }

    void IWidget.Expanded()
    {
        //_Host.Refresh(this);
    }

    void IWidget.HideSettings()
    {
    }

    void IWidget.Init(IWidgetHost host)
    {
        //this._Host = host;
    }

    void IWidget.Maximized()
    {
    }

    void IWidget.Restored()
    {

    }

    void IWidget.ShowSettings()
    {
    }

    #endregion WidgetMethods

    protected override void OnPreRender(EventArgs e)
    {
        base.OnPreRender(e);
    }

    protected void Page_Load(object sender, EventArgs e)
    {
        if (!IsPostBack)
        {
            Map1.MapBackground.BackgroundBrush = new GeoSolidBrush(GeoColor.FromHtml("#E5E3DF"));
            //Map1.CurrentExtent = new RectangleShape(-13939426.6371, 6701997.4056, -7812401.86, 2626987.386962);
            Map1.MapUnit = GeographyUnit.Meter;

            Map1.MapTools.OverlaySwitcher.Enabled = true;
            Map1.MapTools.MouseCoordinate.Enabled = true;
            Map1.MapTools.PanZoomBar.Enabled = true;
            Map1.MapTools.OverlaySwitcher.OnClientBaseOverlayChanged = "onLayerChanged";

            SimpleMarkerOverlay markerOverlay = new SimpleMarkerOverlay("MarkerOverlay");
            markerOverlay.AutoRefreshInterval = TimeSpan.FromMilliseconds(3000);
            markerOverlay.Tick += new EventHandler<EventArgs>(markerOverlay_Tick);
            Map1.CustomOverlays.Add(markerOverlay);

            GoogleOverlay google = new GoogleOverlay("Google Map");
            google.GoogleMapType = ThinkGeo.MapSuite.WebEdition.GoogleMapType.Normal;
            google.JavaScriptLibraryUri = new Uri("http://maps.google.com/maps?file=api&v=2&client=gme-astrataasia&sensor=true");
            Map1.CustomOverlays.Add(google);

            DrawAssetsInMap();

            Body.Height = 600;
        }
        
    }

    void markerOverlay_Tick(object sender, EventArgs e)
    {
        SimpleMarkerOverlay markerOverlay = (SimpleMarkerOverlay)Map1.CustomOverlays["MarkerOverlay"];
        //markerOverlay.Markers.Clear();

        foreach(Marker marker in markerOverlay.Markers)
        {
            double delta = new Random(Guid.NewGuid().GetHashCode()).Next(-11, 26) / 500.0;
            marker.Position.X = marker.Position.X + delta;
            marker.Position.Y = marker.Position.Y + delta;

            //markerOverlay.Markers.Add(marker);
        }

        //DrawAssetsInMap();
    }

    private void DrawAssetsInMap()
    {
        FleetManager fleetManager = new FleetManager();

         //Get the latest event of Assets in WatchList
        EventReport[] latestDeviceEvents = fleetManager.GetLatestAssetEvents(Profile.UserName);

        
        if (latestDeviceEvents != null)
        {
            Proj4Projection proj4 = new Proj4Projection();
            proj4.InternalProjectionParametersString = Proj4Projection.GetEpsgParametersString(4326);
            proj4.ExternalProjectionParametersString = Proj4Projection.GetGoogleMapParametersString();
            proj4.Open();

            string assetIcon = string.Empty;
            SimpleMarkerOverlay markerOverlay = (SimpleMarkerOverlay)Map1.CustomOverlays["MarkerOverlay"];
            foreach (EventReport eventReport in latestDeviceEvents)
            {
                assetIcon = GetAssetIcon(eventReport);

                double lat = AcmeCor.EBE.Common.Utilities.Conversion.MSecToDegrees(eventReport.Latitude);
                double lng = AcmeCor.EBE.Common.Utilities.Conversion.MSecToDegrees(eventReport.Longitude);
                PointShape position = new PointShape(lng, lat);
                PointShape projectedPosition = proj4.ConvertToExternalProjection(position) as PointShape;

                WebImage webImage = new WebImage(assetIcon, 44, 44, 22, 22);
                webImage.Text = eventReport.AssetName;
                //webImage.TextOffsetX = 22.0f;
                //webImage.TextOffsetY = -50.0f;
                webImage.TextBackgroundColor = GeoColor.FromArgb(1, GeoColor.StandardColors.White);

                Marker projectedMarker = new Marker(projectedPosition, webImage);
                projectedMarker.Id = eventReport.AssetId.ToString();// +" " + eventReport.EventCodeEnum.ToString();

                markerOverlay.Markers.Add(projectedMarker);
            }
            proj4.Close();
        }
    }

    private string GetAssetIcon(EventReport evt)
    {
        AssetManager _assetManager = new AssetManager();
        Asset asset = _assetManager.GetAssetById(evt.AssetId);

        string sIcon = string.Empty;

        switch ((AssetType)asset.AssetType)
        {
            case AssetType.PrivateVehicle:
                sIcon = SiteGlobalSettings.markerAssetTypePrivateVehicle;
                break;
            case AssetType.Bus:
                sIcon = SiteGlobalSettings.markerAssetTypeBus;
                break;
            case AssetType.Equipment:
                sIcon = SiteGlobalSettings.markerAssetTypeEquipment;
                break;
            case AssetType.HeavyCommercial:
                sIcon = SiteGlobalSettings.markerAssetTypeHeavyCommercial;
                break;
            case AssetType.LightCommercial:
                sIcon = SiteGlobalSettings.markerAssetTypeLightCommercial;
                break;
            case AssetType.Military:
                sIcon = SiteGlobalSettings.markerAssetTypeMilitary;
                break;
            case AssetType.Motorcycle:
                sIcon = SiteGlobalSettings.markerAssetTypeMotorcycle;
                break;
            case AssetType.SpecialFunctionVehicle:
                sIcon = SiteGlobalSettings.markerAssetTypeSpecialFunctionVehicle;
                break;
            case AssetType.Person:
                sIcon = SiteGlobalSettings.markerAssetTypeSpecialFunctionVehicle;
                break;
            case AssetType.Boat:
                sIcon = SiteGlobalSettings.markerAssetTypeBoat;
                break;
            case AssetType.Container:
                sIcon = SiteGlobalSettings.markerAssetTypeContainer;
                break;
            case AssetType.Other:
                sIcon = SiteGlobalSettings.markerAssetTypePrivateVehicle;
                break;
            default:
                sIcon = SiteGlobalSettings.markerAssetTypeOther;
                break;

        }

        string imgext = sIcon.Substring(sIcon.LastIndexOf("."), 4);
        string iconPath = sIcon.Remove(sIcon.LastIndexOf("."));

        string ignitionStatus = (evt.InputActiveArray[0]) ? "igon" : "igoff";
        string trackingStatus = string.Empty;
        string sPointer = string.Empty;

        if (evt.IsTracking)
        {
            trackingStatus = (evt.HighReportRateActive) ? "hrr" : "nrr";

            if (evt.InputActiveArray[0]) // ignition is on
            {
                if (evt.Speed == 0)
                {
                    sPointer = "_stop";
                }
                else // get direction
                {
                    ushort iHeading = evt.Heading;

                    if (((iHeading >= 339) && (iHeading < 360)) || ((iHeading >= 0) && (iHeading < 24)))
                    {
                        sPointer = "_n";
                    }
                    else if ((iHeading >= 24) && (iHeading < 69))
                    {
                        sPointer = "_ne";
                    }
                    else if ((iHeading >= 69) && (iHeading < 114))
                    {
                        sPointer = "_e";
                    }
                    else if ((iHeading >= 114) && (iHeading < 159))
                    {
                        sPointer = "_se";
                    }
                    else if ((iHeading >= 159) && (iHeading < 204))
                    {
                        sPointer = "_s";
                    }
                    else if ((iHeading >= 204) && (iHeading < 249))
                    {
                        sPointer = "_sw";
                    }
                    else if ((iHeading >= 249) && (iHeading < 294))
                    {
                        sPointer = "_w";
                    }
                    else if ((iHeading >= 294) && (iHeading < 339))
                    {
                        sPointer = "_nw";
                    }
                }
            }
        }
        else
        {
            trackingStatus = "ntr";
        }

        sIcon = iconPath + "_" + ignitionStatus + "_" + trackingStatus + sPointer + imgext;

        return sIcon;
    }


    protected void Map1_ExtentChanged(object sender, ExtentChangedEventArgs e)
    {
        RectangleShape CurrentExtent = Map1.CurrentExtent;

    }

    #endregion Methods
}
